
; PROGRAM RGB.ASM

        LIST    p=16F84 ; PIC16F84 is the target processor
 
RTCC   EQU 1
STATUS EQU 3      ;STATUS REGISTER
PORT_B EQU 6      ;PORT B
PORT_A EQU 5      ;PORT A

INTCON EQU 0BH
MSB    EQU 7
COUNTR EQU 0CH
DLYCNT EQU 010H
BUFFER EQU 0AH
BARS    EQU 0EH
MSEC_20 EQU 020H  ;050H
DB1     EQU 8
GP      EQU 8
DB2     EQU 0FH
LIGHTS  EQU 0DH


RED   EQU 0  ;PORT A VGA CONNEX
GREEN EQU 1
BLUE  EQU 2
LINE  EQU 3
FRAME EQU 3

            ;PORT B
RSW EQU 7   ;SWITCHES
GSW EQU 6
BSW EQU 5
ASW EQU 4


RLED EQU 0  ;LEDS
GLED EQU 1
BLED EQU 2
 
        ORG 0
        GOTO START

        ORG 4
        GOTO INTSVC


START

     CALL DELAYSLEEP
     BSF 3,5
     MOVLW B'11110000' ;
     MOVWF 6


     BSF PORT_A,LINE
     BSF PORT_A,FRAME

     MOVLW B'0000'
     MOVWF  5

     BCF 3,5
     BSF  INTCON,7
     BSF  INTCON,3
BUG
     BCF PORT_B,RLED
     BCF PORT_B,GLED
     BCF PORT_B,BLED

     MOVLW 0
     MOVWF LIGHTS
     SLEEP
     NOP
     NOP
ALL
     BTFSC LIGHTS,0
     GOTO A
     BTFSC LIGHTS,1
     GOTO BB
     BTFSC LIGHTS,2
     GOTO C
     BTFSC LIGHTS,3
     GOTO D

     GOTO BUG



INTSVC
     BCF INTCON,3    ;DISABLE INT
     MOVLW 0
     MOVWF LIGHTS
     CALL DELAYSLEEP 

;CHECK SWITCHES
     BTFSS PORT_B,RSW
     BSF LIGHTS,0
     BTFSS PORT_B,GSW
     BSF LIGHTS,1
     BTFSS PORT_B,BSW
     BSF LIGHTS,2
     BTFSS PORT_B,ASW
     BSF LIGHTS,3
     BSF INTCON,3    ;ENABLE INT
     BCF INTCON,0    ;CLEAR FLAG
     RETFIE


A    BSF PORT_B,RLED
     BCF PORT_B,GLED
     BCF PORT_B,BLED

CYCLE
    ;FRAME
    BCF PORT_B,FRAME
    CALL DELAY
    BSF PORT_B,FRAME

    MOVLW B'00000111'
    OPTION
    MOVLW .62      
    MOVWF RTCC

LINES

    BCF PORT_A,LINE  ;LINE SYNC
    NOP
    BCF PORT_A,RED
    BSF PORT_A,LINE

FIELDS
     BSF PORT_A,RED
     BCF PORT_A,GREEN
     BCF PORT_A,BLUE
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     BTFSC LIGHTS,3
     GOTO D
     BTFSC LIGHTS,2
     GOTO C
     BTFSC LIGHTS,1
     GOTO BB
     NOP
     BTFSS RTCC,7
     GOTO LINES
     NOP
     GOTO CYCLE


BB   BSF PORT_B,GLED
     BCF PORT_B,RLED
     BCF PORT_B,BLED

CYCLE_B
    ;FRAME
    BCF PORT_B,FRAME
    CALL DELAY
    BSF PORT_B,FRAME

    MOVLW B'00000111'
    OPTION
    MOVLW .60
    MOVWF RTCC

LINES_B

    BCF PORT_A,LINE  ;LINE SYNC
    NOP
    BCF PORT_A,GREEN
    BSF PORT_A,LINE

FIELDS_B
     BSF PORT_A,GREEN
     BCF PORT_A,RED
     BCF PORT_A,BLUE
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     BTFSC LIGHTS,3
     GOTO D
     BTFSC LIGHTS,2
     GOTO C
     BTFSC LIGHTS,0
     GOTO A
     NOP
     BTFSS RTCC,7
     GOTO LINES_B
     NOP
     GOTO CYCLE_B


C    BSF PORT_B,BLED
     BCF PORT_B,RLED
     BCF PORT_B,GLED

CYCLE_C
    ;FRAME
    BCF PORT_B,FRAME
    CALL DELAY
    BSF PORT_B,FRAME

    MOVLW B'00000111'
    OPTION
    MOVLW .60
    MOVWF RTCC

LINES_C

    BCF PORT_A,LINE  ;LINE SYNC
    NOP
    BCF PORT_A,BLUE
    BSF PORT_A,LINE

FIELDS_C
     BSF PORT_A,BLUE
     BCF PORT_A,RED
     BCF PORT_A,GREEN
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     BTFSC LIGHTS,3
     GOTO D
     BTFSC LIGHTS,1
     GOTO BB
     BTFSC LIGHTS,0
     GOTO A
     NOP
     BTFSS RTCC,7
     GOTO LINES_C
     NOP
     GOTO CYCLE_C


D    BSF PORT_B,BLED
     BSF PORT_B,RLED
     BSF PORT_B,GLED

CYCLE_D
    ;FRAME
    BCF PORT_B,FRAME
    CALL DELAY
    BSF PORT_B,FRAME

    MOVLW B'00000111'
    OPTION
    MOVLW .60
    MOVWF RTCC

LINES_D

    BCF PORT_A,LINE  ;LINE SYNC
    BCF PORT_A,RED
    BCF PORT_A,BLUE
    BCF PORT_A,GREEN
    BSF PORT_A,LINE

FIELDS_D
     BSF PORT_A,RED
     BSF PORT_A,GREEN
     BSF PORT_A,BLUE
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     NOP
     BTFSC LIGHTS,2
     GOTO C
     BTFSC LIGHTS,1
     GOTO BB
     BTFSC LIGHTS,0
     GOTO A
     NOP
     NOP
     NOP
     BTFSS RTCC,7
     GOTO LINES_D
     NOP
     GOTO CYCLE_D

DELAY
     MOVLW .18
     MOVWF DLYCNT
LOOP DECFSZ DLYCNT,1
     GOTO LOOP
     RETLW 0

DELAYSLEEP
     MOVLW MSEC_20
     MOVWF DB1
DLY1
     CLRWDT
     CLRF DB2
     DECFSZ DB1,1
     GOTO DLY2
     RETLW 0

DLY2 CLRWDT
     DECFSZ DB2,1
     GOTO DLY2
     GOTO DLY1
     RETLW 0

     END
