
                                  LIST    p=16C84

E         EQU 1     ;RB1   LCD
RS        EQU 2     ;RB2   LCD
TXD       EQU 3     ;RB3
MSN       EQU 4     ;RB4
LSN       EQU 5     ;RB5
ENTER     EQU 6     ;RB6
SQUIRT    EQU 7     ;RB7
PORT_A    EQU 5      ;PORT A  LCD DATA BUS
PORT_B    EQU 6      ;PORT B  CONTROL/MONITOR
DEBOUNCE EQU 0FFH

INDF      EQU 0
RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
FSR       EQU 4
BAUD9600  EQU .33
COUNTER   EQU 0CH    ;ADDRESS  COUNTER
A_N       EQU 0DH    ;ALPHANUMERIC COUNTER
ADDRESS   EQU 0EH    ;LCD ADDRESS
COUNTR    EQU 0FH
BUFFER    EQU 010H
DATABYTE  EQU 011H
STRING    EQU 012H
ASCII     EQU 013H
LCDDATA   EQU 014H
DLYCNT    EQU 015H
LBYTE     EQU 016H
HBYTE     EQU 017H
SLOW      EQU 018H
NUMBER    EQU 019H
CHARS     EQU 01AH


         ORG 0
     MOVLW 0
     TRIS PORT_A
     MOVLW B'11110000'
     TRIS PORT_B
     BCF PORT_B,TXD
     BCF PORT_B,RS
     BCF PORT_B,E
     MOVLW 0FH
     MOVWF PORT_A


CYCLEALL

     CALL INIT_DISPLAY
     CALL GRAPHICS
     CALL SELECTINIT
     CALL SECOND
     CALL SECOND

     CALL INIT_DISPLAY

NEXTDATA
     MOVLW 0C0H      ;080H
     MOVWF STRING
     MOVLW 0
     MOVWF LBYTE
     MOVLW 0
     MOVWF HBYTE

     MOVLW 020H
     MOVWF FSR
     MOVLW 0
     MOVWF NUMBER


INC_DATA

     BTFSS PORT_B,LSN
     CALL GETLOW
     BTFSS PORT_B,MSN
     CALL GETHIGH
     BTFSS PORT_B,ENTER
     CALL PRINTBYTE
     BTFSS PORT_B,SQUIRT
     GOTO SEND
     GOTO INC_DATA


PRINTBYTE
      MOVF STRING,0
      CALL COMMAND
      CALL LONGTIME
      MOVF BUFFER,0
      XORLW 0DH
      BTFSC STATUS,2
      GOTO CARIAGERETURN
      GOTO VV
CARIAGERETURN
      MOVLW 0
      CALL WRITE
      GOTO WW
VV    MOVF BUFFER,0
      CALL WRITE
WW

      INCF STRING,1
      MOVF BUFFER,0
      MOVWF INDF
      INCF FSR,1
      INCF NUMBER,1
      RETLW 0



GETLOW
     INCF LBYTE,1
     MOVF LBYTE,0
     XORLW 010H
     BTFSS STATUS,2
     GOTO  AA
     MOVLW 0
     MOVWF LBYTE
AA
     CALL LDELAY
     CALL GETBYTE
     NOP
     RETLW 0

GETHIGH
     INCF HBYTE,1
     MOVF HBYTE,0
     XORLW 010H
     BTFSS STATUS,2
     GOTO BB
     MOVLW 0
     MOVWF HBYTE
BB
     CALL LDELAY
     CALL GETBYTE
     NOP
     RETLW 0

GETBYTE
     MOVLW 080H    ;0C4H
     CALL COMMAND

     MOVLW 0FH
     ANDWF HBYTE,0
     CALL BINARY
     CALL WRITE
     MOVF LBYTE,0
     CALL BINARY
     CALL WRITE


      MOVLW ' '
      CALL WRITE

     SWAPF HBYTE,0
     ADDWF LBYTE,0
     MOVWF BUFFER
     CALL WRITE


     CALL LONGTIME
     RETLW 0


SEND
      MOVF NUMBER,0   ;SAVE NUMBER OF CHARS
      MOVWF CHARS
SEND2
      MOVF CHARS,0
      MOVWF NUMBER
      MOVLW 020H
      MOVWF FSR

ALLSTRING
     CALL DELAY_DATA
      MOVF INDF,0 ;GET DATA
      CALL CONVERT
      CALL TXD_DATA
      INCF FSR,1
      DECFSZ NUMBER,1


      GOTO ALLSTRING
      MOVLW 0C0H
      CALL COMMAND
      MOVLW 0DH
      CALL COMMAND
      CALL SECOND

      BTFSC PORT_B,LSN
      GOTO  SEND2
      GOTO  CYCLEALL

INIT_DISPLAY
     CALL LDELAY

     MOVLW 033H
     CALL COMMAND
     MOVLW 032H
     CALL COMMAND
     MOVLW 028H
     CALL COMMAND
     MOVLW 6
     CALL COMMAND
     MOVLW 0EH
     CALL COMMAND
     MOVLW 1
     CALL COMMAND
     CALL LDELAY
     RETLW 0


SELECTINIT
     MOVLW 080H   ;1ST LINE    8TH POSITON
     CALL COMMAND

     MOVLW 07EH
     CALL WRITE
     MOVLW 'R'
     CALL WRITE
     MOVLW 'e'
     CALL WRITE
     MOVLW 'a'
     CALL WRITE
     MOVLW 'd'
     CALL WRITE
     MOVLW 'y'
     CALL WRITE
     RETLW 0

COMMAND
     MOVWF LCDDATA
     SWAPF LCDDATA,0
     MOVWF PORT_A
     BCF PORT_B,RS
     BSF PORT_B,E
     CALL LDELAY
     BCF PORT_B,E
     MOVF LCDDATA,0    ;LSNIBBLE
     MOVWF PORT_A
     BCF PORT_B,RS
     BSF PORT_B,E
     CALL LDELAY
     BCF PORT_B,E
     RETLW 0

WRITE
     MOVWF A_N
     SWAPF A_N,0
     MOVWF PORT_A
     BSF PORT_B,RS
     BSF  PORT_B,E
     CALL DELAY_DATA
     BCF PORT_B,E
     MOVF A_N,0
     MOVWF PORT_A
     BSF PORT_B,RS
     BSF  PORT_B,E
     CALL DELAY_DATA
     BCF PORT_B,E
     RETLW 0


TXD_DATA
     BSF PORT_B,TXD
NEXT CALL DELAY
     RRF BUFFER,1
     BTFSC STATUS,0
     BSF PORT_B,TXD

     BTFSS STATUS,0
     BCF PORT_B,TXD
     DECFSZ COUNTR,1
     GOTO NEXT
     CALL DELAY
     BCF PORT_B,TXD
     CALL DELAY
     CALL DELAY
     RETLW 0

CONVERT
     XORLW 0FFH
     MOVWF BUFFER
     MOVLW 8
     MOVWF COUNTR
     RETLW 0

DELAY
       MOVLW BAUD9600
       MOVWF DLYCNT
REDX DECFSZ DLYCNT,1
       GOTO REDX
       NOP
       RETLW 0

LDELAY
       MOVLW B'00000011'
       OPTION
       CLRF RTCC
L_DELAY
       CLRWDT
       BTFSS RTCC,7
       GOTO L_DELAY
       RETLW 0

DELAY_DATA
       MOVLW DEBOUNCE
       MOVWF DLYCNT
REDB DECFSZ DLYCNT,1
      goto REDB
       CLRWDT
       RETLW 0


BINARY
     ADDWF PC
     RETLW '0'
     RETLW '1'
     RETLW '2'
     RETLW '3'
     RETLW '4'
     RETLW '5'
     RETLW '6'
     RETLW '7'
     RETLW '8'
     RETLW '9'
     RETLW 'A'
     RETLW 'B'
     RETLW 'C'
     RETLW 'D'
     RETLW 'E'
     RETLW 'F'



LONGTIME
     ;1000.23 MS = 32
     MOVLW 8
     MOVWF SLOW
     MOVLW B'00000111'
     OPTION
LONGX CLRF RTCC
LONG CLRWDT
     NOP
     BTFSS RTCC,7
     GOTO LONG
     DECFSZ SLOW,1
     GOTO LONGX
     RETLW 0



SECOND
     ;1000.23 MS = 32
     MOVLW .32
     MOVWF SLOW
     MOVLW B'00000111'
     OPTION
LONGA CLRF RTCC
LON  CLRWDT
     NOP
     BTFSS RTCC,7
     GOTO LON
     DECFSZ SLOW,1
     GOTO LONGA
     RETLW 0

GRAPHICS
     MOVLW 040H
     CALL COMMAND

     MOVLW 0EH
     CALL WRITE
     MOVLW 010H
     CALL WRITE
     MOVLW 0EH
     CALL WRITE
     MOVLW 0
     CALL WRITE
     MOVLW 01CH
     CALL WRITE
     MOVLW 012H
     CALL WRITE
     MOVLW 01CH
     CALL WRITE
     MOVLW 012H
     CALL WRITE
     RETLW 0

      END

