


        LIST    p=16F84

E         EQU 1      ;RB1   LCD
RS        EQU 2      ;RB2   LCD
RTCC      EQU 1      ;RTCC
PC        EQU 2
STATUS    EQU 3      ;STATUS REGISTER
PORT_A    EQU 5      ;PORT A  LCD DATA BUS
PORT_B    EQU 6      ;PORT B  CONTROL/MONITOR
A_N       EQU 0DH    ;ALPHANUMERIC COUNTER
DLYCNT    EQU 012H
LCDDATA   EQU 014H
 
        ORG 0
 
    MOVLW 0
    TRIS PORT_A
    MOVLW 0
    TRIS PORT_B
                   
    BCF PORT_B,RS
    BCF PORT_B,E
    MOVLW 0FH
    MOVWF PORT_A
    CALL INIT_DISPLAY
    CALL GRAPHICS
    CALL MESSAGE
    SLEEP


INIT_DISPLAY
    CALL LDELAY

    MOVLW 033H
    CALL COMMAND
    MOVLW 032H
    CALL COMMAND
    MOVLW 028H
    CALL COMMAND
    MOVLW 6
    CALL COMMAND
    MOVLW 0EH
    CALL COMMAND
    MOVLW 1
    CALL COMMAND
    CALL LDELAY
    RETLW 0



COMMAND
    MOVWF LCDDATA
    SWAPF LCDDATA,0    ;MSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E

    MOVF LCDDATA,0     ;LSNIBBLE
    MOVWF PORT_A
    BCF PORT_B,RS
    BSF PORT_B,E
    CALL LDELAY
    BCF PORT_B,E
    RETLW 0



WRITE
    MOVWF A_N
    SWAPF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E

    MOVF A_N,0
    MOVWF PORT_A
    BSF PORT_B,RS
    BSF  PORT_B,E
    CALL DELAY_DATA
    BCF PORT_B,E
    RETLW 0

 

GRAPHICS
     MOVLW 040H
     CALL COMMAND


     MOVLW 0        ;HEART SHAPE -ADDRESS 0
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 015H
     CALL WRITE
     MOVLW 011H
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 4
     CALL WRITE
     MOVLW 0
     CALL WRITE
     MOVLW 0
     CALL WRITE
   

     MOVLW 0        ;HEART INVERTED- ADDRESS 1
     CALL WRITE
     MOVLW 0AH
     CALL WRITE
     MOVLW 01FH
     CALL WRITE
     MOVLW 01FH
     CALL WRITE
     MOVLW 0EH
     CALL WRITE
     MOVLW 4
     CALL WRITE
     MOVLW 0
     CALL WRITE
     MOVLW 0
     CALL WRITE

     RETLW 0




MESSAGE

    MOVLW 0A9H       ;2ND LINE
    CALL COMMAND

    MOVLW 'H'
    CALL WRITE
    MOVLW 'U'
    CALL WRITE
    MOVLW 'L'
    CALL WRITE
    MOVLW 'L'
    CALL WRITE
    MOVLW 'O'
    CALL WRITE

    MOVLW ' '      ;SPACE
    CALL WRITE
    MOVLW 0        ;HEART
    CALL WRITE
    MOVLW 1        ;HEART INVERTED
    CALL WRITE
 
  
DELAY_DATA
      MOVLW 0FFH
      MOVWF DLYCNT
REDB DECFSZ DLYCNT,1
      goto REDB
      RETLW 0
LDELAY
      MOVLW B'00000011'
      OPTION
      CLRF RTCC
L_DELAY
      BTFSS RTCC,7
      GOTO L_DELAY
      RETLW 0
 
 
      END
