  
 
#include <p18f252.h>
#include <delays.h>
 #include "IMAGE2.h"
 
 
#define ROJO 0b000111 11
#define VERDE 0b11100011
#define AZUL 0b11111100

#define AMARILLO 0b00000011
#define CELESTE 0b11100000

#define NEGRO  0xff
#define BLANCO 0
 
#define  SCLK PORTBbits.RB3
#define  SDATA  PORTBbits.RB2
#define  CS	 PORTBbits.RB1
#define  RESET   PORTBbits.RB0

#define CMD		0
#define DATA	1


#define black  0xff                              //180
#define yellow 0                          // 61


  


 

#define  GCLCDX         132
#define  GCLCDY         132
  

#define  X_START        1
#define  Y_START        1
#define  X_END          (GCLCDX-1)
#define  Y_END          (GCLCDY-1)

#define  SOFT_RESET     0x01                //  0x01
#define  COLOR_8_BIT    0x02
#define  COLOR_16_BIT   0x05
#define  BOOSTER_ON     0x03
#define  SLEEP_OUT      0x11
#define  DISPLAY_ON     0x29
#define  MEM_CONTROL    0x36
#define  COLMOD			0x3A
#define  SETCON         0x25
#define  ADDRX          0x2A
#define  ADDRY          0x2B
#define  MEMWRITE       0x2C
#define  RGBSET			0x2D

 



#define  BLACK          RGB(0x00, 0x00, 0x00)
#define  WHITE          RGB(0xFF, 0xFF, 0xFF)
#define  RED            RGB(0xFF, 0x00, 0x00)
#define  GREEN          RGB(0x00, 0xFF, 0x00)
#define  BLUE           RGB(0x00, 0x00, 0xFF)
#define  YELLOW         RGB(0xFF, 0xFF, 0x00)
#define  MAGENTA        RGB(0xFF, 0x00, 0xFF)
#define  CYAN           RGB(0x00, 0xFF, 0xFF)
#define  GRAY           RGB(0x80, 0x80, 0x40)
#define  SILVER         RGB(0xA0, 0xA0, 0x80)
#define  GOLD           RGB(0xA0, 0xA0, 0x40)

  

 
#define TRUE  1
#define FALSE 0
 

extern void SleepMS(int MilliSeconds);

void send( unsigned char nokia_data, unsigned char cd);
  
void delay10( char n); 
 
 

void nokia_cs(void);

 
void main(void) ;
void nokiacolorinit(void);
void plot(void);
 
void gclcd_init(void);
void gclcd_cmd(int  cmd);
 
void gclcd_const(unsigned int  *buffer, unsigned int  count);
void gclcd_cls(void);
void gclcd_setarea(int  startx, int  endx, int  starty, int  endy);
void gclcd_contrast(int  contrast);
void gclcd_img(unsigned int  x, unsigned int  y);
void gclcd_font(void);
int gclcd_putc(int  c);
void gclcd_newline(void);
void gclcd_gotoxy(unsigned int  x, unsigned int  y);
void gclcd_pixel(unsigned int  x, unsigned int  y, int  color);
  

  
 
void gclcd_img(unsigned int x, unsigned int y); 
void gclcd_setarea(int  startx, int  endx, int  starty, int  endy);

unsigned int xCoord=0;
unsigned int yCoord=0;



void main(void) 
  {
   int  i ;
   char z;
   char q; 
   int roms;



   SleepMS(1000);
   TRISA = 0x00;
   TRISB = 0x00;		 
      
   PORTB = 0xff;	 
      
   PORTA=0xff;
   TRISC =0x80;
   PORTC=0xff;


       gclcd_init( );

   gclcd_img(55,70);
   

  _asm

  sleep

  _endasm






    
}

void gclcd_img(unsigned int x, unsigned int y)
{
   unsigned int  IMGENDX, IMGENDY, i;

   IMGENDX = img[0];
   IMGENDY = img[1];

   gclcd_setarea(x,IMGENDX-1+x,y,IMGENDY-1+y);

	send(MEMWRITE,CMD);
	for(i=0; i<(IMGENDX*IMGENDY); i++)
   {
     
         send(img[i+2] >> 8,DATA);
     

         send(img[i+2],DATA);
 
   }
}


void gclcd_setarea(int  startx, int  endx, int  starty, int  endy)
{
	send(ADDRX,CMD);
	send(startx,DATA);
	send(endx,DATA);
	send(ADDRY,CMD);
	send(starty,DATA);
	send(endy,DATA);
	xCoord=startx;
	yCoord=starty;   
}





 

 

void send( unsigned char nokia_data, unsigned char cd)  

 { 
 int c;
  

	CS=0;
 
	SCLK=0;
    
	if(cd == CMD)
		SDATA=0;
	else
		SDATA=1;
	SCLK=1;

	for (c=0;c<8;c++)
         {
	 
    

	SCLK = 0;								 
			if ((nokia_data&0x80)==0x80) {SDATA=1;}		 
			else {SDATA=0;}
	SCLK = 1;							 
			nokia_data=nokia_data<<1;	
  
  
 	}

     CS=1;

      
}




 
 

 
  
void gclcd_init(void)

 
{
    

  

    CS=FALSE  ;           
    RESET=FALSE;           

 

    RESET=TRUE;      // output_bit(RST,TRUE);
	 SleepMS(25);

     SCLK=TRUE;      // output_bit(SCK,TRUE);
     SDATA=TRUE;     // output_bit(SDO,TRUE);
      CS=TRUE;       //  output_bit(CS,TRUE);

     send(SOFT_RESET,CMD);             
    SleepMS(25);
 

     send(SLEEP_OUT,CMD);              
     send(DISPLAY_ON,CMD);            
     send(BOOSTER_ON,CMD);             

     send(COLMOD,CMD);                 
     send(5,DATA);                     
     SleepMS(25);


    



  	send(MEM_CONTROL,CMD);         
    send(0b01001000,DATA);          
     send(SETCON,CMD);
     send(60,DATA);
 
    

 

    send(RGBSET,CMD);
   
    send(2,DATA);         
    send(4,DATA);     
    send(8,DATA);      
    send(9,DATA);           
    send(10,DATA);       
    send(11,DATA);              
    send(13,DATA);       
    send(15,DATA);     
    // GREEN
    send(0,DATA);           
    send(2,DATA);         
    send(4,DATA);         
    send(6,DATA);     
    send(9,DATA);     
    send(11,DATA);      
    send(13,DATA);
    send(15,DATA);     
    
    //BLUE
    send(0,DATA);     
    send(4,DATA);     
    send(11,DATA);      
    send(15,DATA);     

     
    SleepMS(25);
  







}




