 
 
#include <p18f252.h>
#include <delays.h>
 



#define ROJO 0b000111 11
#define VERDE 0b11100011
#define AZUL 0b11111100

#define AMARILLO 0b00000011
#define CELESTE 0b11100000

#define NEGRO  0xff
#define BLANCO 0
 
#define SCLK PORTBbits.RB3
#define SDATA  PORTBbits.RB2
#define CS	 PORTBbits.RB1
#define RESET   PORTBbits.RB0

#define CMD		0
#define DATA	1


#define black  0xff                              //180
#define yellow 0                          // 61



#define DISON       0xaf   
#define DISOFF      0xae   
#define DISNOR      0xa6  
#define DISINV      0xa7  
#define COMSCN      0xbb   
#define DISCTL      0xca   
#define SLPIN       0x95   
#define SLPOUT      0x94   
#define PASET       0x75   
#define CASET       0x15   
#define DATCTL      0xbc   
#define RGBSET8     0xce   
#define RAMWR       0x5c   
#define RAMRD       0x5d   
#define PTLIN       0xa8   
#define PTLOUT      0xa9   
#define RMWIN       0xe0   
#define RMWOUT      0xee   
#define ASCSET      0xaa   
#define SCSTART     0xab   
#define OSCON       0xd1   
#define OSCOFF      0xd2   
#define PWRCTR      0x20   
#define VOLCTR      0x81   
#define VOLUP       0xd6   
#define VOLDOWN     0xd7   
#define TMPGRD      0x82   
#define EPCTIN      0xcd   
#define EPCOUT      0xcc   
#define EPMWR       0xfc   
#define EPMRD       0xfd   
#define EPSRRD1     0x7c   
#define EPSRRD2     0x7d   
#define NOP         0x25    
  





#define  HIGH_COLOR     // Por defecto 64k colores
#define  SCREEN_COLOR   WHITE
#define  USE_GRFCN

#define  GCLCDX         132
#define  GCLCDY         132
  

#define  X_START        1
#define  Y_START        1
#define  X_END          (GCLCDX-1)
#define  Y_END          (GCLCDY-1)

#define  SOFT_RESET     0x01                //  0x01
#define  COLOR_8_BIT    0x02
#define  COLOR_16_BIT   0x05
#define  BOOSTER_ON     0x03
#define  SLEEP_OUT      0x11
#define  DISPLAY_ON     0x29
#define  MEM_CONTROL    0x36
#define  COLMOD			0x3A
#define  SETCON         0x25
#define  ADDRX          0x2A
#define  ADDRY          0x2B
#define  MEMWRITE       0x2C
#define  RGBSET			0x2D

 




#define  BLACK          RGB(0x00, 0x00, 0x00)
#define  WHITE          RGB(0xFF, 0xFF, 0xFF)
#define  RED            RGB(0xFF, 0x00, 0x00)
#define  GREEN          RGB(0x00, 0xFF, 0x00)
#define  BLUE           RGB(0x00, 0x00, 0xFF)
#define  YELLOW         RGB(0xFF, 0xFF, 0x00)
#define  MAGENTA        RGB(0xFF, 0x00, 0xFF)
#define  CYAN           RGB(0x00, 0xFF, 0xFF)
#define  GRAY           RGB(0x80, 0x80, 0x40)
#define  SILVER         RGB(0xA0, 0xA0, 0x80)
#define  GOLD           RGB(0xA0, 0xA0, 0x40)

 
#define TRUE  1
#define FALSE 0


 
 
#pragma romdata  TABLE=0x0900
 

  const rom  unsigned char img[ ]= { 

 
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB5,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xD6,0xB6,0xB6,0xD6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,
0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xD6,0xD6,0xD2,0xB2,0xB2,0xB2,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,
0xB1,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD2,0xB2,0xB2,0xB2,0xD2,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,
0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xB2,0xD2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB5,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB1,0xB1,
0xB1,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,
0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,
0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,
0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,
0xB1,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x92,0x92,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,
0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xD6,0xB6,0xB2,0x92,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x96,0xB6,0xB6,0x92,0x92,0x92,0xB6,0xB2,0x92,0x8D,0x8D,0x92,0xB2,0x92,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x6D,
0xB1,0xB2,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xD6,0xDA,0xDA,0xD6,0xD6,0xB6,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x8D,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x8D,0x91,0x92,0x92,0x91,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x91,0x91,0x6D,0x6D,0x6D,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xD6,0xDA,0xDA,0xD6,0xB6,0xB2,0x92,0x92,0x92,0x92,0xB2,0xB2,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x6D,0x8D,0x6D,0x6D,0x8D,0x92,0x92,0x92,0x92,0x8D,0x91,0xB2,0xB2,0x91,0x8D,0x8D,0x91,0x92,0x91,0x91,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xB6,0xB6,0xD6,0xDA,0xB6,0xB6,0xB2,0x92,0x92,0x92,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x6D,0x69,0x49,0x49,0x49,0x69,0x69,0x69,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x92,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x4D,0x4D,0x4D,0x6D,0x6D,0x71,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xB6,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x6D,0x69,0x49,0x69,0x6D,0x6D,0x6D,0x49,0x69,0x8D,0x91,0x6D,0x6D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x49,0x4D,0x6D,0x6D,0x6D,0x71,0x92,0x92,0x96,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0x92,0x8D,0x8D,0x8D,0x91,0x8D,0x6D,0x6D,0x69,0x6D,0x6D,0x69,0x6D,0x8D,0x8D,0x6D,0x69,0x49,0x6D,0x6D,0x69,0x6D,0x6D,0x69,0x69,0x92,0xB2,0xB6,0xD6,0xDA,0xFF,0xFF,0xDB,0x92,0x92,0x96,0x96,0xB6,0xB6,0xB6,0xB6,0x96,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0x92,0x92,0xB2,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x49,0x6D,0x6D,0x69,0x6D,0x8D,0x8D,0x6D,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x92,0xDA,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xDA,0xB6,0x96,0x92,0x92,0x92,0x92,0x6D,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0x8D,0x92,0xB2,0x92,0x6D,0x6D,0x6D,0x6D,0x8D,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x69,0x6D,0x69,0x49,0x49,0x49,0x49,0x49,0x49,0x6D,0x6D,0x92,0xDB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xB6,0x92,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0x8D,0x92,0xB2,0x92,0x91,0x91,0x6D,0x6D,0x91,0x8D,0x6D,0x8D,0x6D,0x69,0x69,0x6D,0x6D,0x6D,0x49,0x49,0x6D,0x4D,0x6D,0x91,0xB6,0xB6,0xB6,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDB,0x49,0x49,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x69,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xD6,0xDA,0xD6,0xB6,0xB6,0x92,0x8D,0x91,0xB2,0x92,0x92,0x92,0x8D,0x91,0x92,0x92,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0x92,0x92,0x96,0xB6,0xB6,0xB6,0xDA,0xDB,0xFF,0xDB,0xDB,0xB6,0x72,0x6E,0x29,0x49,0x49,0x49,0x6D,0x6D,0x8D,0x6D,0x6D,0x6D,
0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xD6,0xDA,0xB6,0xB6,0xB6,0xB2,0x91,0x91,0x92,0x92,0x92,0x92,0x91,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x92,0x92,0x96,0x96,0x96,0x92,0x92,0x92,0x4D,0x6D,0x6D,0x6D,0x49,0x49,0x49,0x29,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x8D,0x6D,0x69,
0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB6,0xD6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x92,0x92,0xB6,0x92,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x72,0x92,0x6D,0x6D,0x49,0x49,0x49,0x49,0x49,0x4D,0x4D,0x4D,0x4D,0x6D,0x6D,0x6D,0x6D,0x69,0x6D,0x6D,0x8D,0x6D,0x6D,0x69,
0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB6,0xD6,0xD6,0xB6,0xB6,0xB2,0x92,0x92,0x92,0xB2,0xB6,0xB6,0x92,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x49,0x49,0x49,0x49,0x6D,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,
0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0xB2,0xB6,0x92,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x4D,0x6D,0x6D,0x49,0x49,0x49,0x6D,0x92,0x92,0x6D,0x4D,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xE0,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x6D,0x6D,0x91,0x91,0x91,0x92,0x6D,0x91,0x91,0x91,0x91,0x6D,0x6D,0x49,0x6D,0x49,0x6D,0x6D,0x69,0x6D,0x6D,0x91,0x91,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0x92,0x91,0x91,0x6D,0x6D,0x8D,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xB2,0xE0,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xD6,0xD6,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xB6,0xB6,0x92,0x92,0x6D,0x6D,0x6D,0x91,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x6D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x49,0x91,0x92,0x92,0x92,0x91,0x8D,0x8D,0x91,0x91,
0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xB2,0xE0,0xE0,0xE0,0xE0,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB6,0xD6,0xB6,0xB2,0x92,0x8D,0x6D,0x8D,0x91,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x8D,0x8D,0x6D,0x8D,0x8D,0x8D,0x91,0x91,0x8D,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x92,0x92,0x92,0x92,0x91,0x8D,0x8D,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB1,0xB2,0xD2,0xE0,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB6,0xD6,0xD6,0xB6,0xB2,0x92,0xB2,0xB6,0xB2,0x92,0x6D,0x6D,0x6D,0x92,0x91,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xB1,0xB2,0xB2,0xE0,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x6D,0x6D,0x6D,0x6D,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0x92,0x91,0x92,0x92,0x92,0x91,0x91,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xB2,0xE0,0xE0,0xE0,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0x91,0x6D,0x69,0x6D,0x71,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0x91,0x92,0x92,0xB6,0xB2,0x92,0x91,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xB2,0xB1,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x6D,0x6D,0x6D,0x6D,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0xB2,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0x92,0x91,0x91,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0x8D,0x6D,0x6D,0x8D,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0x92,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB6,0xB2,0x91,0x91,0x91,0x91,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xD6,0xD6,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0x92,0x92,0xB2,0xB6,0xB2,0xB2,0xB1,0xB1,0x91,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB1,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0x92,0x92,0xB6,0xB6,0xB2,0x91,0x91,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x8D,0x91,0x92,0x91,0x92,0x92,0x92,0x92,0x92,0x91,0x92,0x92,0x92,0x91,0x92,0x92,0xB2,0xB2,0xB2,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0x69,0x69,0x8D,0x91,0x91,0x92,0xB2,0xB6,0xB2,0xB2,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0x92,0xB6,0xB2,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0xB2,0xB2,
0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x91,0x92,0x92,0xB2,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xB6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0x69,0x6D,0x8D,0xB1,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,
0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x92,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xFA,0xFA,0xD6,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0x91,0x8D,0x8D,0x8D,0xB1,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0x92,0xB2,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,
0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xFA,0xD6,0xB2,0xB1,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xDA,0xFA,0xFA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0x8D,0x69,0x69,0x8D,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0x92,0xB2,0x92,0xB2,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0xB2,0x92,0xB2,
0x92,0x92,0x92,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x8D,0x91,0x91,0x91,0x92,0x92,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0x91,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xB2,0x91,0xD6,0xB6,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0x91,0xB1,0xB1,0x91,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB6,0x92,0xB6,0xB6,0xB2,0xB2,0xB6,0xB2,0x92,0x92,0x92,0x92,0x92,
0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x91,0xB6,0xFF,0xFF,0xFF,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0xB1,0xB1,0x91,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,
0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x92,0x92,0x92,0x91,0x92,0x91,0x91,0x92,0x91,0x91,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD2,0xD2,0xD6,0xD6,0xD6,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xD6,0xFB,0xFB,0xFB,0xFA,0xD6,0xB6,0x92,0x6D,0x91,0xB6,0xFF,0xFF,0xFF,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x92,0x92,0x91,0x6D,0x6D,0x92,0x8E,0x6D,0x92,0x92,0x8E,0x92,0x92,0x92,0x92,0x92,0x92,
0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xDB,0x96,0xB6,0xB6,0xB6,0xFF,0xFB,0xDA,0xDA,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB1,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x4D,0x4D,0x6D,0xB6,0xDA,0xDA,0xB6,0x92,0x8E,0x8E,0x92,0x8D,0x8E,0x92,0x92,
0x71,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x71,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB6,0xB2,0xB6,0xD6,0xD6,0xB6,0xB6,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0xB6,0xB6,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xB6,0x92,0x91,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x4D,0x49,0x49,0x49,0x49,0x29,0x29,0x4D,0x71,0xBA,0xDF,0xFF,0xFF,0xFF,0xDB,0xDA,0xB6,0x92,0x6D,0x92,0x72,0x72,
0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x71,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB2,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0x92,0x92,0x96,0xB6,0xB6,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDF,0xFF,0xFF,0xFF,0xFF,0xDA,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB1,0x91,0x91,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x69,0x6D,0x49,0x49,0x49,0x49,0x29,0x49,0x49,0x4D,0x72,0x72,0x72,0xFF,0xDF,0xDF,0xFF,0xFF,0xFF,0xFF,0xDF,0xBB,0x72,0x6E,0x6E,0x6E,
0x49,0x6D,0x4D,0x4D,0x4D,0x49,0x49,0x4D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB6,0xB6,0x92,0x92,0x92,0x92,0xB6,0xB6,0xDA,0xB6,0xDA,0xB6,0x92,0xB6,0xB6,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x92,0xB2,0xB6,0xB6,0xDA,0xDA,0xDB,0xFB,0xFB,0xFB,0xDB,0xDB,0xB6,0xB6,0x92,0x92,0x92,0x91,0x92,0xDA,0xDA,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0xB1,0xB2,0xB2,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x49,0x49,0x49,0x49,0x4D,0x4D,0x4D,0x4D,0x96,0x96,0x96,0xDF,0xDF,0xDF,0xDF,0xFF,0xDF,0xDF,0xFF,0xFF,0xDB,0x6E,0x49,0x4D,
0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x4D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0x92,0xB6,0xDA,0xDA,0xDA,0xD6,0xB6,0xB6,0xB2,0x92,0x92,0x92,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0xB2,0xB2,0x92,0x92,0x8D,0x6D,0x6D,0x49,0x6D,0xB6,0xDA,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0x91,0x91,0x91,0xB1,0x91,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x6D,0x6D,0x4D,0x4D,0x4D,0x4E,0x4E,0x4E,0x4E,0x72,0xDF,0xDF,0xDF,0xDF,0xDF,0xDF,0xFF,0xFF,0xDF,0xDF,0xDF,0x6E,0x4D,0x49,
0x49,0x49,0x49,0x49,0x49,0x49,0x4D,0x4D,0x4D,0x4D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0xB6,0xDA,0xDB,0xFF,0xFF,0xB6,0x92,0x6D,0x6D,0x6D,0x6D,0x69,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x91,0x6D,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB2,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x49,0x6D,0x71,0x92,0x72,0x6D,0x4D,0x4E,0x4E,0x72,0x4D,0x4E,0xDF,0xDF,0xFF,0xDF,0xFF,0xDF,0xFF,0xFF,0xDF,0xDF,0xDF,0x72,0x4E,0x4E,
0x49,0x49,0x4D,0x49,0x49,0x4D,0x6D,0x6D,0x4D,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0xB6,0xFF,0xFF,0xFF,0xDA,0x6D,0x49,0x49,0x49,0x69,0x6D,0x8D,0x8D,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0x91,0x6D,0x6D,0x91,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0x96,0x96,0x72,0x4D,0x4D,0x4D,0x4E,0x4E,0x4E,0x4A,0x4E,0x72,0x97,0xBB,0xDF,0xFF,0xDF,0xDF,0xDF,0xDF,0xBB,0x6E,0x4E,0x72,
0x49,0x49,0x49,0x49,0x49,0x4D,0x6D,0x6D,0x4D,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0xB6,0xDF,0xDB,0xB6,0x6D,0x49,0x49,0x69,0x6D,0x8D,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0x92,0x6D,0x6D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0x91,0x8D,0x8D,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0xB6,0x96,0x96,0x72,0x4D,0x4D,0x4D,0x4E,0x4E,0x4E,0x05,0x05,0x29,0x29,0x4E,0x97,0xBB,0xBB,0xDB,0xBB,0x96,0x6E,0x4D,0x6E,0x72,
0x49,0x49,0x49,0x49,0x49,0x4D,0x6D,0x6D,0x49,0x49,0x49,0x49,0x69,0x69,0x69,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0xB6,0x92,0x4D,0x6D,0x49,0x69,0x6D,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xB6,0x91,0x6D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x91,0x8D,0x8D,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x6D,0x92,0xB6,0xB6,0x96,0x92,0x71,0x4D,0x4D,0x6E,0x72,0x4E,0x29,0x05,0x05,0x29,0x29,0x29,0x4D,0x4D,0x4D,0x4D,0x4D,0x49,0x6E,0x72,0x6E,
0x49,0x25,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x69,0x69,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0xB2,0x92,0x92,0x92,0xB2,0xB2,0xB6,0xB6,0xB6,0x92,0x6D,0x4D,0x92,0xDA,0xDA,0xB6,0x91,0x8D,0xB2,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xB6,0x91,0x6D,0x6D,0x8D,0x92,0xB2,0xB2,0xB2,0x91,0x91,0xB1,0xB1,0x91,0x91,0x8D,0x8D,0x6D,0x6D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x92,0xB6,0xB6,0xB6,0x96,0x72,0x6D,0x4D,0x4D,0x72,0x4D,0x4D,0x29,0x4D,0x6E,0x6E,0x4D,0x4D,0x4D,0x6D,0x6E,0x6E,0x6E,0x6E,0x6E,0x6D,
0x49,0x24,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0x92,0xB6,0x92,0x71,0x6D,0x96,0xFF,0xFF,0xDA,0xB2,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB6,0xB6,0xB1,0x8D,0x6D,0x8D,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0xB1,0xB1,0x91,0x8D,0x8D,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x92,0xB6,0xB6,0x96,0x96,0x72,0x6D,0x4D,0x4D,0x4D,0x4D,0x4D,0x49,0x4D,0x72,0x72,0x72,0x6D,0x6E,0x72,0x72,0x92,0x72,0x6D,0x6D,0x6D,
0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0xB2,0x92,0xB6,0x92,0x71,0x6D,0x92,0xFF,0xFF,0xFF,0xB6,0x91,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB2,0x91,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x92,0x92,0x92,0x92,0x92,0x71,0x6D,0x6D,0x4D,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x8D,0x6D,0x6D,0x6D,
0x49,0x49,0x49,0x49,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0xB2,0x92,0x6D,0x6D,0x96,0xFF,0xFF,0xFF,0xDA,0x92,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x91,0x92,0xB6,0xB2,0xB2,0xB2,0xB1,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x71,0x71,0x91,0x91,0x91,0x91,0x71,0x8D,0x8D,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,
0x49,0x49,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x91,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x6D,0x6D,0xDA,0xFF,0xFF,0xFF,0xFF,0xDA,0xB2,0x8D,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x91,0x8D,0x8D,0x91,0x92,0x92,0x92,0x92,0xB2,0x91,0x91,0x91,0x8D,0x8D,0x6D,0x8D,0x8D,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x91,0x91,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,
0x49,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0x92,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x91,0x92,0x71,0x6D,0xDF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x8D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x6D,0x69,0x69,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x92,0xB2,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,
0x49,0x4D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0xB2,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0x92,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0xB2,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x6D,0x6D,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xB2,0xB2,0x8D,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0x91,0x91,0x91,0x91,0x8D,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,
0x49,0x6D,0x6D,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x92,0x92,0xB2,0xB2,0x92,0x92,0x91,0x91,0x92,0x91,0x8D,0x91,0x92,0x6D,0x6D,0xBA,0xFF,0xFF,0xFF,0xFF,0xDB,0x92,0x6D,0x8D,0x8D,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0xB1,0x91,0x6D,0x69,0x6D,0x6D,0x8D,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x8D,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x6D,0x69,0x69,0x8D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x91,0x8D,
0x69,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x91,0x92,0x92,0x96,0x92,0x92,0xB6,0xB6,0x96,0x96,0x91,0x91,0x91,0x91,0xB2,0x91,0x91,0xB2,0xB2,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x92,0x91,0x91,0x91,0x91,0x6D,0x6D,0x72,0xDB,0xFF,0xDF,0xFF,0xDF,0x92,0x8D,0x8D,0x6D,0x8D,0x8D,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0x91,0x6D,0x6D,0xDA,0xFF,0xDA,0xDA,0x91,0x91,0x91,0x92,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,
0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x96,0x96,0x96,0x92,0xB6,0xB6,0x96,0x96,0x96,0x96,0x91,0x91,0x91,0xB2,0x8D,0x91,0x91,0x8D,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x71,0x91,0x91,0x91,0x91,0x91,0x6D,0x4D,0x6D,0xBA,0xFF,0xDF,0xFF,0xBA,0x6D,0x69,0x69,0x69,0x8D,0x8D,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xB2,0xB1,0x91,0x8D,0x8D,0x91,0xB6,0xFF,0xFF,0xFF,0xDA,0x91,0xB6,0xB6,0x92,0x8D,0x6D,0x69,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,
0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB6,0x96,0x96,0x96,0xB6,0x96,0x92,0x91,0x91,0xB2,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x71,0x91,0x91,0x91,0x91,0x91,0x6D,0x4D,0x6D,0x96,0xFF,0xFF,0xDF,0xB6,0x49,0x49,0x69,0x6D,0x8D,0x8D,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0x8D,0xDA,0xFF,0xFF,0xFF,0xFF,0xDE,0x92,0x92,0xB6,0x92,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,
0x8D,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0x92,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0x69,0x6D,0x49,0x6D,0x6D,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x6D,0x6D,0x49,0x4D,0x92,0xDF,0xDF,0xDF,0x96,0x49,0x6D,0x8D,0x92,0x8D,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x6D,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xB6,0x71,0x92,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,
0x6D,0x8D,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x49,0x91,0x6D,0x92,0x92,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x4D,0x6E,0x96,0xDF,0xDF,0xDF,0xB6,0x6D,0x91,0x92,0xB2,0x91,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x8D,0x8D,0x6D,0xFA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xB6,0x96,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,
0x6D,0x8D,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x91,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x92,0xDA,0xDB,0xFF,0xFF,0xBA,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x49,0x6E,0x92,0xBB,0xDF,0xDF,0xDF,0xDB,0x96,0x92,0x92,0x92,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x6D,0xB6,0xFF,0xDA,0xDA,0xDF,0xFF,0xFF,0xB6,0x92,0xB6,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,
0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x91,0x6D,0x6D,0x4D,0x4D,0x4D,0x4D,0x4D,0x49,0x96,0xDF,0xDF,0xFF,0xFF,0xFF,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x49,0x6D,0x96,0xBA,0xDF,0xDF,0xDF,0xDF,0xDF,0xDA,0xB6,0x92,0x8D,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD2,0xD2,0xD6,0xD6,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x6D,0x6D,0x91,0xB2,0xB6,0xB6,0xDA,0xB6,0x6D,0x91,0xB6,0xB6,0xB6,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB2,0xB2,0xB2,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,
0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x4D,0x49,0x29,0x49,0x4D,0x4D,0x4D,0x4D,0x92,0xFF,0xFF,0xFF,0xFF,0xDF,0x72,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0xBA,0xDB,0xDF,0xDF,0xDF,0xDF,0xFF,0xDF,0xDA,0x92,0x8D,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0x8D,0x6D,0x8D,0x8D,0x91,0x91,0x6D,0x69,0x91,0x92,0xB6,0xB6,0xB6,0x91,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB1,0x91,0xB1,0xB1,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,
0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x4D,0x49,0x49,0x25,0x29,0x49,0x29,0x29,0x05,0x29,0x29,0x4D,0x96,0xDF,0xDF,0xDF,0xBA,0x4D,0x92,0x92,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x92,0xBA,0xDF,0xFF,0xDF,0xBA,0x96,0xBB,0xDB,0xB6,0x91,0x6D,0x8D,0xB1,0xB1,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0xB6,0xB6,0xDA,0xB6,0x92,0x8D,0x6D,0x6D,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB6,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,
0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x6D,0x49,0x29,0x25,0x25,0x29,0x4D,0x29,0x29,0x05,0x05,0x4D,0x52,0x04,0x29,0x4D,0x4D,0x4D,0x29,0x4D,0x96,0x96,0x96,0x72,0x71,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x96,0xDB,0xDF,0xDF,0xBA,0x96,0xBA,0xDA,0xB6,0x8D,0x8D,0x8D,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB1,0xB1,0x8D,0x91,0xB1,0xB1,0xB2,0xB1,0x91,0x8D,0x91,0xB6,0xD6,0xD6,0xB6,0x92,0x91,0x6D,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xB6,0xB5,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,
0x8D,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x71,0x6D,0x49,0x49,0x29,0x24,0x24,0x29,0x4D,0x29,0x4D,0x05,0x05,0xDF,0xDF,0xDF,0x72,0x29,0x4D,0x2D,0x29,0x4D,0x72,0x96,0xB6,0xB6,0x96,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x6D,0x92,0xB6,0xBB,0xB6,0xBA,0xDB,0xDA,0xB6,0x8D,0x8D,0x8D,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB1,0xB1,0x8D,0x8D,0x91,0xB1,0xB1,0xB2,0xB1,0x91,0x6D,0x8D,0xB2,0xB6,0xD6,0xB6,0x92,0x91,0x91,0x91,0x92,0x92,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB5,0xB5,0xB5,0xB1,0xB1,0xB1,0xB1,
0x8D,0x6D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x6D,0x49,0x49,0x49,0x49,0x29,0x29,0x29,0x4D,0x49,0x29,0x00,0x4D,0xDF,0xDF,0xFF,0xBA,0x4D,0x4D,0x4D,0x29,0x4D,0x71,0x96,0xB6,0xB6,0xB6,0x92,0x91,0x6D,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x49,0x72,0x96,0xB6,0xB6,0xBA,0xDB,0xDA,0xB2,0x8D,0x8D,0x8D,0xB1,0xB1,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD2,0xD2,0xD2,0xB2,0xB1,0xB1,0xB1,0xB1,0x8D,0x8D,0xB1,0xB1,0xB1,0xB2,0x8D,0x6D,0x8D,0x92,0xB6,0xDA,0xB6,0xB6,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB1,0xB1,0xB1,0xB1,
0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x8D,0x6D,0x49,0x49,0x29,0x49,0x6D,0x6D,0x6D,0x4D,0x29,0x29,0x49,0x29,0x04,0x6D,0xBA,0xDF,0xBA,0x71,0x6D,0x4D,0x4D,0x4D,0x4D,0x92,0x96,0x96,0xB6,0x96,0x92,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x69,0x49,0x49,0x6D,0x96,0x92,0x96,0xB6,0xB6,0xB6,0x92,0x8D,0x91,0xB1,0xB1,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x8D,0x8D,0x8D,0x91,0xB1,0xB2,0xB2,0x91,0x6D,0x8D,0x92,0xB6,0xDA,0xDA,0xB6,0x92,0x91,0x91,0x91,0x91,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,
0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x6D,0x6D,0x49,0x29,0x29,0x49,0x6D,0x92,0x92,0x71,0x4D,0x4D,0x29,0x29,0x49,0x00,0x00,0x4D,0x29,0x29,0x29,0x29,0x4D,0x4D,0x49,0x4D,0x71,0x92,0x92,0x92,0x92,0x8D,0x6D,0x69,0x69,0x6D,0x8D,0x8D,0x6D,0x69,0x6D,0x92,0x92,0x72,0x6D,0x6D,0x71,0x91,0x8D,0x8D,0xB1,0xB1,0xB1,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD2,0xD2,0xB2,0xB2,0xB2,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0x8D,0x8D,0x91,0xB1,0xB6,0xB2,0x8D,0x6D,0x6D,0x91,0xB6,0xDA,0xBA,0xB6,0x92,0x92,0x91,0x91,0x91,0x91,0xB1,0xB1,0xB1,0x91,0x91,0x91,0x91,0xB1,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,
0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x49,0x24,0x29,0x49,0x6D,0x92,0x96,0x92,0x71,0x4D,0x29,0x25,0x49,0x29,0x49,0x04,0x00,0x24,0x00,0x49,0x29,0x4D,0x4D,0x49,0x6D,0x6D,0x91,0x71,0x6D,0x6D,0x6D,0x6D,0x69,0x69,0x6D,0x8D,0x8D,0x6D,0x6D,0x8D,0x92,0x92,0x6D,0x49,0x49,0x49,0x6D,0x8D,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD2,0xD2,0xD2,0xD2,0xD2,0xD6,0xD2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB1,0x91,0x8D,0x6D,0x91,0x92,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x91,0x91,0xB1,0xB1,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x8D,0xB2,
0x8D,0x6D,0x8D,0x6D,0x6D,0x6D,0x6D,0x49,0x24,0x24,0x49,0x6D,0x92,0x96,0x92,0x92,0x71,0x6D,0x49,0x4D,0x29,0x49,0x49,0x49,0x49,0x29,0x49,0x49,0x6D,0x49,0x49,0x6D,0x4D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x8D,0x92,0x92,0x71,0x6D,0x49,0x25,0x49,0x6D,0x8D,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0x91,0xB1,0x91,0xB1,0xB2,0xB2,0xB2,0x8D,0x6D,0x6D,0x92,0xB6,0xB6,0xDA,0xD6,0xB6,0xB6,0xB2,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0xB2,0xB2,0xB2,0x92,0x91,0x92,0x91,0x8D,0x8D,0x91,0xB2,0xB6,0xB6,0xB6,
0x6D,0x8D,0x6D,0x6D,0x6D,0x6D,0x49,0x24,0x24,0x24,0x6D,0x6D,0x92,0x92,0x92,0x92,0x92,0x71,0x4D,0x4D,0x49,0x49,0x49,0x49,0x49,0x4D,0x6D,0x71,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x8D,0x91,0x91,0x91,0x6D,0x6D,0x49,0x49,0x69,0x8D,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0x91,0x91,0x8D,0x8D,0x92,0xB6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0x92,0x92,0x92,0xB2,0x92,0x92,0x92,0x91,0xB2,0xDA,0xFB,0xFB,0xFF,0xFF,0xFF,0xFF,
0x6D,0x6D,0x6D,0x6D,0x49,0x49,0x24,0x24,0x24,0x49,0x4D,0x6D,0x71,0x92,0x92,0x92,0x92,0x92,0x6D,0x4D,0x49,0x49,0x49,0x49,0x4D,0x6D,0x6D,0x91,0x91,0x71,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x6D,0x6D,0x69,0x49,0x69,0x69,0x8D,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x8D,0x8D,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB6,0xB2,0x92,0xB6,0xDB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0x6D,0x69,0x6D,0x69,0x49,0x24,0x24,0x24,0x44,0x49,0x4D,0x6D,0x6D,0x71,0x92,0x92,0x92,0x92,0x71,0x6D,0x4D,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x6D,0x6D,0x69,0x49,0x69,0x69,0x8D,0x91,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x6D,0x6D,0x8D,0x92,0xB2,0xB2,0x92,0x92,0x92,0x92,0x92,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,
0x6D,0x69,0x69,0x49,0x44,0x24,0x24,0x44,0x49,0x49,0x49,0x4D,0x6D,0x6D,0x71,0x71,0x91,0x91,0x71,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x91,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x69,0x69,0x6D,0x8D,0x91,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0x91,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x92,0x92,0x92,0x92,0x92,0x92,0x92,0x91,0x91,0x91,0xB6,0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xD6,0xD6,
0x69,0x69,0x49,0x49,0x44,0x44,0x49,0x49,0x49,0x69,0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x69,0x6D,0x8D,0x91,0x91,0xB1,0xB1,0xB1,0xB1,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0x8D,0x8D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x69,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0x8D,0x8D,
0x49,0x69,0x49,0x48,0x44,0x48,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x91,0x91,0x8D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x69,0x6D,0x8D,0x8D,0x91,0xB1,0xB1,0xB1,0xB1,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x6D,0x8E,0x6D,0x6D,0x6D,0x8D,0x92,0x92,0xB2,
0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x6D,0x8D,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x6D,0x6D,0x6D,0x6D,0x6D,0x69,0x69,0x6D,0x8D,0x8D,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xB6,0xB6,0xB6,0xB6,0xB6,0xE0,0xB2,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xB6,0xB2,0xE0,0xE0,0xE0,0xD6,
0x69,0x69,0x49,0x49,0x49,0x49,0x49,0x49,0x69,0x6D,0x6D,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0x6D,0x69,0x6D,0x8D,0x8D,0x6D,0x69,0x6D,0x8D,0x8D,0x91,0xB1,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xB6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xB6,0xB2,0xB2,0xE0,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB6,0xD6,0xD6,0xE0,0xE0,0xB6,0xB6,0xE0,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xE0,0xB6,0xE0,0xB2,0xB6,0xB2,0xE0,
0x69,0x69,0x49,0x49,0x49,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x69,0x69,0x69,0x6D,0x69,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x6D,0x69,0x49,0x6D,0x8D,0x8D,0x8D,0x6D,0x8D,0x8D,0x91,0x91,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xB6,0xB2,0xE0,0xE0,0xB2,0xE0,0xB2,0xB2,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xB6,0xB6,0xE0,0xB6,0xE0,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xE0,0xB2,0xB2,0xE0,0xB2,0xB2,0xB6,0xE0,
0x69,0x69,0x69,0x49,0x49,0x49,0x69,0x6D,0x6D,0x6D,0x69,0x69,0x69,0x69,0x69,0x69,0x69,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x91,0x8D,0x6D,0x69,0x6D,0x6D,0x6D,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xB6,0xE0,0xB2,0xE0,0xB2,0xE0,0xB2,0xE0,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xE0,0xB2,0xB2,0xE0,0xB6,0xD6,0xE0,0xD6,0xD6,0xE0,0xE0,0xE0,0xE0,0xD6,0xD6,0xD6,0xD6,0xE0,0xD6,0xB6,0xB6,0xB6,0xE0,0xE0,0xE0,0xB2,
0x49,0x49,0x6D,0x69,0x49,0x69,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x6D,0x6D,0x8D,0x8D,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xE0,0xE0,0xB2,0xB2,0xE0,0xB2,0xE0,0xE0,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xD6,0xE0,0xD6,0xD6,0xB6,0xE0,
0x49,0x49,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x8D,0x69,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x6D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xE0,0xB6,0xB6,0xB2,0xE0,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xE0,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xE0,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xE0,
0x49,0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0x92,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x6D,0x69,0x6D,0x8D,0x8D,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xE0,0xE0,0xE0,0xB2,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xB2,0xB2,0xB2,0xB2,0xE0,0xD6,0xD6,0xD6,0xE0,0xE0,0xE0,0xD6,0xD6,0xD6,0xE0,0xD6,0xD6,0xD6,0xD6,0xD6,0xE0,0xE0,0xE0,0xD6,
0x69,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x91,0x8D,0x69,0x69,0x6D,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x69,0xE0,0xE0,0xE0,0xE0,0x6D,0x6D,0x6D,0xE0,0xE0,0xE0,0x6D,0x6D,0xE0,0xE0,0xE0,0xE0,0x8D,0x8D,0xE0,0xE0,0xE0,0xE0,0xE0,0x91,0xE0,0xE0,0xE0,0xE0,0xE0,0xB2,0xE0,0xE0,0xE0,0xE0,0xE0,0xB2,0xB2,0xBC,0xBC,0xBC,0x8D,0x69,0x6D,0x6D,0xBC,0x91,0x91,0x91,0x91,0xBC,0xBC,0xBC,0x8D,0x8D,0x91,0xBC,0xBC,0xBC,0xB1,0xB2,0xB2,0xB2,0xB6,0xBC,0xD6,0xD6,0xD6,0xD6,0xD6,0xBC,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0x1F,0xB2,0xB2,0xB2,0xB2,0xB2,0x1F,0xB2,0xB2,0xB6,0x1F,0xD6,0xD6,0xF7,0xF7,0xF7,0xD6,0xD6,0xF7,0xD6,0xB6,0xB2,0xF7,0xB6,0xF7,0xD6,0xD6,0xD6,
0x49,0xE0,0x6D,0x6D,0x6D,0xE0,0x8D,0xE0,0x6D,0x6D,0x6D,0xE0,0x6D,0xE0,0x8D,0x8D,0x8D,0xE0,0x8D,0xE0,0x8D,0x8D,0x8D,0x91,0x91,0xE0,0x91,0x91,0xB2,0xB2,0xB2,0xE0,0xB6,0xB6,0xB6,0xB6,0xB2,0xBC,0x91,0x91,0x8D,0xBC,0x69,0x6D,0xBC,0xBC,0x91,0x91,0x91,0xBC,0x8D,0x6D,0x8D,0xBC,0x8D,0xBC,0x91,0x91,0xB1,0xBC,0xB2,0xB2,0xB2,0xBC,0xBC,0xB6,0xD6,0xD6,0xD6,0xBC,0xBC,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0x1F,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xD6,0xD6,0x1F,0xB6,0xB2,0xB2,0xB2,0xB2,0x1F,0xB2,0xB2,0x1F,0xB6,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xB2,0xB2,0xF7,0xD6,0xF7,0xD6,0xD6,0xF7,
0x6D,0xE0,0x6D,0x6D,0x6D,0xE0,0x6D,0xE0,0x6D,0x6D,0x6D,0x6D,0x6D,0xE0,0x6D,0x8D,0x8D,0xE0,0x8D,0xE0,0x8D,0x8D,0x8D,0x91,0xB1,0xE0,0xB1,0xB1,0xB2,0xB2,0xB2,0xE0,0xB6,0xB6,0xB6,0xB6,0xB2,0xBC,0x92,0x91,0xBC,0xBC,0x6D,0x8D,0x91,0xBC,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0xBC,0x8D,0x91,0x91,0x91,0xB1,0xBC,0xB2,0xB2,0xBC,0xB6,0xBC,0xD6,0xD6,0xD6,0xBC,0xD6,0xBC,0xD6,0xD6,0x1F,0xD6,0xD6,0x1F,0xD6,0xB6,0x1F,0x1F,0x1F,0x1F,0xB2,0xB2,0xB2,0x1F,0x1F,0x1F,0xB2,0xB2,0xB2,0x1F,0x1F,0x1F,0x1F,0xB2,0x1F,0x1F,0x1F,0x1F,0xD6,0xD6,0x1F,0xD6,0xD6,0xD6,0xD6,0xD2,0x1F,0xB2,0x1F,0xB2,0xD6,0xD6,0xF7,0xD6,0xD6,0xD6,0xD6,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xF7,0xD6,
0x6D,0xE0,0xE0,0xE0,0xE0,0x6D,0x6D,0xE0,0x6D,0x6D,0x6D,0x6D,0x6D,0xE0,0x8D,0x8D,0x8D,0xE0,0x8D,0xE0,0xE0,0xE0,0xE0,0x91,0xB1,0xE0,0xE0,0xE0,0xE0,0xB2,0xB6,0xE0,0xE0,0xE0,0xE0,0xB6,0xB6,0xBC,0x91,0xBC,0x6D,0xBC,0x8D,0x91,0x91,0xBC,0x91,0x91,0x91,0x91,0x6D,0xBC,0xBC,0x8D,0x8D,0x91,0xBC,0xBC,0xBC,0xB1,0xB2,0xBC,0xB2,0xB6,0xBC,0xB6,0xD6,0xBC,0xD6,0xD6,0xBC,0xD6,0xD6,0x1F,0xD6,0xD6,0x1F,0xD6,0xD6,0xB6,0x1F,0xB6,0xB6,0xB2,0xB2,0x1F,0xB2,0xB2,0xB2,0xB2,0xB1,0x1F,0xB2,0xB2,0xB2,0x1F,0xB2,0x1F,0xD6,0xD6,0xD6,0x1F,0xD6,0x1F,0xD6,0xD6,0xD6,0xD6,0xD6,0x1F,0x1F,0xB2,0xD2,0xD6,0xD6,0xF7,0xD6,0xF7,0xF7,0xF7,0xD6,0xF7,0xF7,0xF7,0xF7,0xF7,0xD6,0xF7,0xF7,0xD6,0xD6,
0x6D,0xE0,0x6D,0x6D,0x6D,0xE0,0x6D,0xE0,0x6D,0x6D,0x6D,0x6D,0x6D,0xE0,0x8D,0x8D,0x8D,0xE0,0x8D,0xE0,0x8D,0x91,0x91,0xB1,0xB1,0xE0,0xB1,0xB1,0xB2,0xB2,0xB6,0xE0,0xB6,0xB6,0xB6,0xB6,0x92,0xBC,0xBC,0x69,0x6D,0xBC,0x91,0x91,0x91,0xBC,0x91,0x91,0x91,0x91,0xBC,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0xB1,0xBC,0xB2,0xBC,0xBC,0xBC,0xBC,0xBC,0xD6,0xBC,0xBC,0xBC,0xBC,0xBC,0xD6,0x1F,0xD6,0xD6,0x1F,0xD6,0xD6,0xB6,0x1F,0xB6,0xB6,0xB6,0xB2,0xB2,0x1F,0x1F,0x1F,0xB2,0xB1,0x1F,0xB2,0xB2,0xB2,0x1F,0xB2,0x1F,0xD6,0xD6,0xD6,0x1F,0xD6,0x1F,0xD6,0xD6,0xD6,0xD6,0xD6,0x1F,0xB2,0x1F,0xB2,0xD6,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xF7,0xD6,
0x6D,0xE0,0x6D,0x6D,0x6D,0xE0,0x6D,0xE0,0x6D,0x6D,0x6D,0xE0,0x8D,0xE0,0x8D,0x8D,0x8D,0xE0,0x8D,0xE0,0x91,0x91,0x91,0xB1,0xB1,0xE0,0xB2,0x92,0xB2,0xB6,0xB6,0xE0,0xB6,0xB6,0xB6,0x92,0x8D,0xBC,0x69,0x6D,0x8D,0xBC,0xB2,0xB2,0xB2,0xBC,0x92,0xB2,0x91,0xBC,0x6D,0x8D,0x8D,0x8D,0x8D,0xBC,0x91,0x91,0xB1,0xBC,0xB2,0xB2,0xB2,0xB6,0xBC,0xD6,0xD6,0xD6,0xD6,0xD6,0xBC,0xD6,0xD6,0x1F,0xD6,0x1F,0x1F,0xD6,0xD6,0xD6,0x1F,0xB6,0x1F,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x1F,0xB1,0x1F,0xB2,0xB2,0xB2,0x1F,0xB2,0x1F,0xD6,0xD6,0xD6,0x1F,0xD6,0x1F,0xD6,0xD6,0xD6,0xD6,0xD6,0x1F,0xB2,0xB2,0x1F,0xD6,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xD6,0xF7,
0x6D,0xE0,0xE0,0xE0,0xE0,0x6D,0x6D,0x6D,0xE0,0xE0,0xE0,0x8D,0x8D,0xE0,0xE0,0xE0,0xE0,0x8D,0x91,0xE0,0xE0,0xE0,0xE0,0xE0,0xB1,0xE0,0xB2,0xB2,0xB2,0xB6,0xB6,0xE0,0xB6,0xB2,0x91,0x6D,0x6D,0x69,0xBC,0xBC,0xBC,0xB2,0xB2,0xB2,0xBC,0xBC,0xBC,0xB2,0x91,0xBC,0xBC,0xBC,0xBC,0xBC,0x8D,0x8D,0xBC,0xBC,0xBC,0xB1,0xB2,0xB2,0xB6,0xB6,0xBC,0xD6,0xD6,0xD6,0xD6,0xD6,0xBC,0xD6,0xD6,0xD6,0x1F,0xD6,0x1F,0xD6,0xD6,0xD6,0xD6,0x1F,0xB2,0xB2,0xB2,0xB2,0x1F,0x1F,0x1F,0xB2,0xB2,0xB2,0x1F,0x1F,0x1F,0x1F,0xB2,0x1F,0x1F,0x1F,0x1F,0xD6,0xD6,0x1F,0x1F,0x1F,0x1F,0x1F,0xD6,0x1F,0xD6,0xD6,0xD6,0x1F,0xD6,0xD6,0xF7,0xF7,0xF7,0xF7,0xD6,0xF7,0xD6,0xD6,0xD6,0xF7,0xD6,0xF7,0xD6,0xD6,0xD6,
0x6D,0x8D,0x6D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0x92,0x91,0x6D,0x6D,0x69,0x6D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x1F,0xB2,0x1F,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0x8D,0x8D,0x8D,0xF7,0x8D,0xF7,0xF7,0xF7,0xF7,0x8D,0x91,0xF7,0x8D,0x91,0x91,0xF7,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x91,0x91,0x6D,0x6D,0x6D,0x8D,0x91,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0xF7,0x8D,0x8D,0xF7,0x8D,0xF7,0x91,0x91,0x8D,0xF7,0x91,0xF7,0x8D,0x91,0x91,0xF7,0x91,0x91,0x91,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x91,0x91,0x6D,0x6D,0x6D,0x8D,0xB1,0xB6,0xB6,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0x92,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0x8D,0xF7,0x8D,0xF7,0x91,0xF7,0x91,0x8D,0x91,0xF7,0x8D,0xF7,0x91,0x91,0x91,0xF7,0x91,0x91,0x91,0x91,0xB2,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x6D,0x6D,0x6D,0x8D,0x91,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0x6D,0x6D,0xF7,0xF7,0x91,0xF7,0xF7,0xF7,0xF7,0x91,0x8D,0xF7,0x91,0x91,0x91,0xF7,0x91,0x91,0x91,0xB2,0xB2,0xB2,0x92,0x92,0x91,0x91,0x6D,0x6D,0x6D,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0x6D,0x6D,0x8D,0xF7,0x91,0xF7,0x91,0x91,0x91,0x91,0x91,0xF7,0x91,0x91,0x91,0xF7,0x91,0xB1,0xB2,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x91,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0xF7,0x91,0x8D,0x8D,0xF7,0x91,0xF7,0x91,0x91,0x91,0x91,0x91,0x91,0xF7,0x91,0xF7,0xB1,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x6D,0x91,0x91,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x91,0x91,0x8D,0x8D,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xF6,0xF6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x91,0xF7,0x91,0x91,0x8D,0xF7,0x91,0xF7,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xF7,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x91,0x8D,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0x91,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xF6,0xF6,0xF6,0xD6,0xD6,0xD6,0xD6,
0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x91,0x8D,0x8D,0x8D,0x8D,0x91,0xB1,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x91,0x91,0x8D,0x8D,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB2,0xB1,0x91,0xB1,0xB1,0xB2,0xB2,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xF6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x71,0x71,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0x91,0xB1,0xB2,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x92,0x91,0x8D,0x8D,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x71,0x71,0x91,0x91,0x91,0x91,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x92,0x92,0x91,0x8D,0x6D,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0x92,0x91,0x91,0x8D,0x8D,0x91,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB1,0xB1,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0x91,0x91,0x8D,0x8D,0x91,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0x91,0x91,0x8D,0x6D,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB1,0xB1,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0x91,0x91,0x8D,0x8D,0x91,0xB2,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB6,0xD6,0xB2,0xB2,0xB1,0xB1,0xB2,0xB2,0xB2,0xD2,0xD2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB6,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0x91,0xB1,0xB1,0xB6,0xB6,0xD6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0x91,0xB1,0xB2,0xB2,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB2,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0x91,0x8D,0x91,0xB1,0xB2,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0x8D,0xB1,0xB2,0xB2,0xB2,0xB2,0xB6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFA,0xFA,0xFA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x8D,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xB2,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFB,0xFB,0xFB,0xFA,0xFA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0x91,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB6,0xB6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0xB2,0xB6,0xB6,0xB2,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFB,0xFF,0xFF,0xFF,0xFF,0xFB,0xFA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB1,0x91,0xB1,0xB2,0xB2,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xFA,0xFB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xD6,0xD6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xB6,0xB2,0x91,0x6D,0x6D,0x8D,0x91,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,0xB1,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xB6,0xB6,0x91,0x6D,0x6D,0x6D,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,0xB1,0xB1,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xB6,0xB6,0x91,0x8D,0x6D,0x8D,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDB,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFB,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB2,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,0xB1,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xB6,0xB2,0x91,0x8D,0x8D,0x8D,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDB,0xDA,0xDB,0xFF,0xFF,0xDB,0xDB,0xDB,0xFB,0xFB,0xFB,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB2,0xB1,
0xB2,0x92,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xB6,0xB2,0x91,0x8D,0x8D,0x91,0x91,0x91,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xFA,0xFA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xD6,0xD6,0xD6,0xB6,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xB6,0xB6,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xAD,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB2,
0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xD6,0xB6,0xB2,0xB2,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x92,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xFA,0xFA,0xDA,0xD6,0xB2,0xB2,0x91,0x91,0xB2,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0x91,0x8D,0x8D,0x8D,0x8D,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xFA,0xFA,0xDA,0xD6,0xB6,0xB2,0x91,0x91,0x91,0xB2,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB2,0xB2,0xB1,0x91,0x8D,0x8D,0x8D,0x6D,0x6D,0x6D,0x6D,0x8D,0x8D,0x8D,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xAD,0xB1,0xB1,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB2,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xFA,0xFA,0xDA,0xD6,0xB2,0x91,0x91,0x91,0xB2,0xB2,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB2,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB6,0xB2,0xB1,0x91,0x91,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x8D,0x91,0x91,0x91,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0x8D,0xB1,0xB2,0xD2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,
0xB2,0xB6,0xB2,0xB2,0xB2,0xB2,0xB6,0xB2,0xB2,0x92,0xB2,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xDA,0xDA,0xDA,0xDA,0xDA,0xD6,0xB6,0xB2,0x91,0x91,0x91,0xB2,0x92,0x92,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0x91,0xB2,0xB2,0xB6,0xB6,0xB6,0xB6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xB6,0xB6,0xB6,0xB2,0xB1,0x91,0x91,0x91,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xB2,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB1,0xB2,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6,0xD6
};











 

extern void SleepMS(int MilliSeconds);

void send( unsigned char nokia_data, unsigned char cd);
void read_rom_table (void);
void read_rom_table2 (void);

void delay10( char n); 
 
void LCD_put_pixel(unsigned char color, unsigned char x, unsigned char y);

void nokia_cs(void);

void nokia_printchar(unsigned char caracter);
void PintarByte(unsigned char bytefornokia);
void nokia_outs(unsigned char * s, unsigned char x, unsigned char y);
void nokia_senddata(unsigned char nokia_data);
void LimpiarPantalla(unsigned char fondo);
 
void main(void) ;
void nokiacolorinit(void);
void plot(void);
 
void gclcd_init(void);
void gclcd_cmd(int  cmd);
 
void gclcd_const(unsigned int  *buffer, unsigned int  count);
void gclcd_cls(void);
void gclcd_setarea(int  startx, int  endx, int  starty, int  endy);
void gclcd_contrast(int  contrast);
void gclcd_img(unsigned int  x, unsigned int  y);
void gclcd_font(void);
int gclcd_putc(int  c);
void gclcd_newline(void);
void gclcd_gotoxy(unsigned int  x, unsigned int  y);
void gclcd_pixel(unsigned int  x, unsigned int  y, int  color);
  
struct _font{
	unsigned int  width;
	unsigned int  height;
}font;



unsigned int  i;
unsigned int  color;
unsigned int  xCoord=0;
unsigned int  yCoord=0;
unsigned int  fontOffset=0;

 



 




void main(void) 
  {
      int   i ;
  char z;
  char q; 
   int roms;
      SleepMS(1000);
    TRISA = 0x00;
    TRISB = 0x00;		// portB is output; (NOKIA LCD = portB) portb4 sw in

      
	PORTB = 0xff;		// all low
            
  
   PORTA=0xff;


  TRISC =0x80;

 PORTC=0xff;
 
       gclcd_init( );
   
   read_rom_table();
 
  


    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);
    SleepMS(9000);

    
    send(0x5c, CMD);
  for (roms=0; roms<17424 ;roms++) // 17161


{  send(0xff, DATA);
}

 
 SleepMS(5000);
 

 
    send(0x5c, CMD);
  for (roms=0; roms<17424 ;roms++) // 17161


{  send(0xe1, DATA);
}

  SleepMS(5000);



    send(0x5c, CMD);
  for (roms=0; roms<17424 ;roms++) // 17161


{  send(0x1e, DATA);
}

    
 SleepMS(5000);



    send(0x5c, CMD);
  for (roms=0; roms<17424 ;roms++) // 17161


{  send(0x07, DATA);
}

 
 	
    SleepMS(5000);
    
 

 send(0xae, CMD);
 send(0x95, CMD);
 send(0xd2, CMD);

 


 PORTA = 0x00;
 PORTB = 0x00;
 PORTC = 0x00;

  _asm

sleep

  _endasm

    
}

 
 

 

void send( unsigned char nokia_data, unsigned char cd) { 
 int c;
	CS=0;

	SCLK=0;
    
	if(cd == CMD)
		SDATA=0;
	else
		SDATA=1;
	SCLK=1;

	for (c=0;c<8;c++)
         {
	 
    

	SCLK = 0;							 
			if ((nokia_data&0x80)==0x80) {SDATA=1;}	 
			else {SDATA=0;}
	SCLK = 1;								 
			nokia_data=nokia_data<<1;	
  
  
 	}

     CS=1;

      
}




void read_rom_table (void)

{
   int roms;
    int number;
 
_asm

    MOVLW 0X09    //10
	MOVFF W,TBLPTRH
	MOVLW 0x00             //0X00
	MOVFF W,TBLPTRL
	MOVLW 0X00
	MOVFF W,TBLPTRU


_endasm

    
 
    send(0x5c, CMD);
  for (roms=0; roms<17163 ;roms++) // 17161
 
 
 {
  _asm
    TBLRD
     MOVFF TABLAT,W
 _endasm 
    number=W;
    asm_rom();



 	send(number, DATA);	

  }  
 }

 

 




void read_rom_table2 (void)

{
   int roms;
    int number;
 
_asm

    MOVLW 0X4c    //10
	MOVFF W,TBLPTRH
	MOVLW 0x10             //0X00
	MOVFF W,TBLPTRL
	MOVLW 0X00
	MOVFF W,TBLPTRU


_endasm

    
 
    send(0x5c, CMD);
  for (roms=0; roms<13231 ;roms++) // 17161
 
 
 {
  _asm
    TBLRD
     MOVFF TABLAT,W
 _endasm 
    number=W;
    asm_rom();



 	send(number, DATA);	

  }  
 }

 

 






 

void nokia_cs(void)
{
	CS=1;	// CS = 1
}



  
void gclcd_init(void)
{
      int i;

   CS=1;
  SleepMS(25);

  

     SCLK=1;
     SDATA=0;


   

      SleepMS(10);  
      RESET=0;
      SleepMS(300);  
      RESET=1;

   SleepMS(500);   
   CS=1;
    

  send(0xca,CMD);   
  send(0x03,DATA);     
  send(32,DATA);      
  send(12,DATA);       
  send(0x0a,DATA);      

  send(0xbb,CMD);       
   send(0x01,DATA);       

  send(0xd1,CMD);        

  send(0x94,CMD);     
  send(0x81,CMD);      
  send(0x22,DATA);         
  send(0x03,DATA);                                                        

  send(0x20,CMD);       
  send(0x0f,DATA);        


  SleepMS(150);          


  send(0xa7,CMD);      

  send(0xbc,CMD);           
  send(0x00,DATA);           
  send(0,DATA);             
  send(0x01,DATA);              
  send(0x00,DATA);            

  send(0xce,CMD);               
    // color table
     
    send(0,DATA);         
    send(2,DATA);     
    send(12,DATA);      
    send(6,DATA);            
    send(8,DATA);       
    send(10,DATA);             
    send(12,DATA);       
    send(15,DATA);      
    // GREEN
    send(0,DATA);            
    send(2,DATA);          
    send(4,DATA);          
    send(6,DATA);     
    send(8,DATA);     
    send(10,DATA);       
    send(12,DATA); 
    send(15,DATA);  
    //BLUE
    send(0,DATA);     
    send(5,DATA);      
    send(10,DATA);       
    send(15,DATA);     

    send(0x25,CMD);
    send(0xaf,CMD);

    SleepMS(500);


   send(NOP,CMD);         

     send(PASET,CMD);        
      send(0,DATA);           
      send(130,DATA);                  
  
     send(CASET,CMD);            
     send(0,DATA);                
      send(130,DATA);               


  send(0xa9,CMD); 



 send(DISON,CMD);
 SleepMS(200);

   for (i=0; i< 125 ; i++);                                  
{
   send(0xd6,CMD);
   SleepMS(10);
  }

   
 
}

 
 











 
